﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Controls.Primitives;
using Infragistics.Controls.Editors;
using Infragistics.Controls.Editors.Primitives;

namespace MultiColumnComboEditorBinding
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        
     
        public MainWindow()
        {
            InitializeComponent();
            var colms = xamMultiColumnComboEditor1.Items;
           
        }

        private void xamMultiColumnComboEditor1_Loaded(object sender, RoutedEventArgs e)
        {
 

            Grid grid = VisualTreeHelper.GetChild(sender as XamMultiColumnComboEditor, 0) as Grid;
            Popup popup = ((grid.Children[0] as Border).Child as Grid).Children[0] as Popup;

            // This will change the white space to gray, you really can't get rid of the space though unless the dropdown size
            // is restricted.
            ((popup.Child as Grid).Children[0] as Border).Background = new SolidColorBrush(Colors.Gray);

            // Handle the popup opened event.  The grid rows will exist by the time this event is fired.
            popup.Opened += new EventHandler(popup_Opened);
        }

        void popup_Opened(object sender, EventArgs e)
        {
            Popup popup = sender as Popup;
            DependencyObject itemsPanel = FindFirstRow(popup.Child);
            if (itemsPanel != null && VisualTreeHelper.GetChildrenCount(itemsPanel) > 0)
            {
                double width = 0;
                for (int i = 0; i < VisualTreeHelper.GetChildrenCount(itemsPanel); i++)
                {
                    ComboCellControl control = VisualTreeHelper.GetChild(itemsPanel, i) as ComboCellControl;
                    width += control.ActualWidth;
                }

                ((popup.Child as System.Windows.Controls.Grid).Children[0] as Border).Width = width + 3;
                popup.MaxWidth = width + 3;
            }
        }

        private DependencyObject FindFirstRow(DependencyObject root)
        {
            for (int i = 0; i < VisualTreeHelper.GetChildrenCount(root); i++)
            {
                DependencyObject dObj = VisualTreeHelper.GetChild(root, i);
                if (dObj.GetType() == typeof(ComboCellsPanel))
                    return dObj;

                dObj = FindFirstRow(dObj);
                if (dObj != null)
                    return dObj;
            }

            return null;
        }

    }
}
